__author__ = "Neil Muller"
__copyright__ = "Copyright (c) 2007 Neil Muller"
__license__ = "MIT-style"

"""
Hello world (purely) in pygame, with a bouncing ball
"""

import pygame
import sys, os

pygame.init()
pygame.display.init()
try:
    pygame.font.init()
except Exception, e:
    print "Unable to initialise font module"
    print e
    sys.exit()

tSize=(800,600)
oScreen=pygame.display.set_mode(tSize)
pygame.display.set_caption("Hello World")
oScreen=pygame.display.get_surface()
oBackground=oScreen.copy()
oBackRect=oBackground.get_rect()

oFont=pygame.font.Font(None,90)
oText=oFont.render('Hello World!',True,(128, 128, 128))
oBackground.blit(oText,(5,5))
oScreen.blit(oBackground,(0,0))
pygame.display.update()

#name=os.path.join('images','blue_circ_8bit.png')
name=os.path.join('images','blue_circ_24bit.png')
#oBall=pygame.image.load(name)
oBall=pygame.image.load(name).convert_alpha()
print oBall.get_bitsize()
print pygame.display.Info()
oBallRect=oBall.get_rect(centerx=oScreen.get_width()/2,
                       centery=oScreen.get_height()/2)
aVelocity=[1,1]

oScreen.blit(oBall,oBallRect)

pygame.display.update(oBallRect)

oClock=pygame.time.Clock()

while True:
    oClock.tick(70)
    event=pygame.event.poll()
    if event.type == pygame.QUIT:
         sys.exit()
    elif event.type == pygame.KEYUP and event.key == pygame.K_q:
         sys.exit()
    oOldBallRect=oBallRect
    oBallRect=oBallRect.move(aVelocity[0],aVelocity[1])
    if oBallRect.bottom>=oBackRect.bottom or oBallRect.top<=oBackRect.top:
        # Bounced at the bottom or top
        aVelocity[1]=-aVelocity[1]
    if oBallRect.right>=oBackRect.right or oBallRect.left<=oBackRect.left:
        # Bounced at the side
        aVelocity[0]=-aVelocity[0]
    oScreen.blit(oBackground,oOldBallRect,oOldBallRect)
    oScreen.blit(oBall,oBallRect)
    #pygame.display.update(oBallRect)
    pygame.display.update([oBallRect,oOldBallRect])


