__author__ = "Neil Muller"
__copyright__ = "Copyright (c) 2007 Neil Muller"
__license__ = "MIT-style"

"""
Display related demo
"""

import pygame
import sys, os

pygame.init()
pygame.display.init()
try:
    pygame.font.init()
except Exception, e:
    print "Unable to initialise font module"
    print e
    sys.exit()

tSize=(800,600)
print pygame.display.mode_ok(tSize,0,32)
oScreen=pygame.display.set_mode(tSize,pygame.DOUBLEBUF|pygame.HWSURFACE,16)
#oScreen=pygame.display.set_mode(tSize,1,8)
print pygame.display.Info()
pygame.display.set_caption("Hello World")
oScreen=pygame.display.get_surface()
oBackground=oScreen.copy()
oBackRect=oBackground.get_rect()

oFont=pygame.font.Font(None,150)
oText=oFont.render('Hello World!',True,(128, 128, 128))
oBackground.blit(oText,(5,5))
oScreen.blit(oBackground,(1,1))
pygame.display.flip()

name=os.path.join('images','blue_circ_24bit.png')
oBall=pygame.image.load(name)
oBallRect=oBall.get_rect(centerx=oScreen.get_width()/2,
                       centery=oScreen.get_height()/2)
aVelocity=[5,5]

oScreen.blit(oBall,oBallRect)

pygame.display.flip()

gamma=1.0

oClock=pygame.time.Clock()

while True:
    oClock.tick(70)
    event=pygame.event.poll()
    if event.type == pygame.QUIT:
         sys.exit()
    elif event.type == pygame.KEYUP and event.key == pygame.K_q:
         sys.exit()
    elif event.type == pygame.KEYDOWN and event.key == pygame.K_f:
         pygame.display.toggle_fullscreen()
    elif event.type == pygame.KEYDOWN and event.key == pygame.K_g:
         gamma-=0.1
         print pygame.display.set_gamma(gamma)
         print gamma
    oOldBallRect=oBallRect
    oBallRect=oBallRect.move(aVelocity[0],aVelocity[1])
    if oBallRect.bottom>=oBackRect.bottom or oBallRect.top<=oBackRect.top:
        # Bounced at the bottom or top
        aVelocity[1]=-aVelocity[1]
    if oBallRect.right>=oBackRect.right or oBallRect.left<=oBackRect.left:
        # Bounced at the side
        aVelocity[0]=-aVelocity[0]
    oScreen.blit(oBackground,(aVelocity[0],aVelocity[1]))
    oScreen.blit(oBall,oBallRect)
    #pygame.display.update(oBallRect)
    pygame.display.flip()



