__author__ = "Neil Muller"
__copyright__ = "Copyright (c) 2007 Neil Muller"
__license__ = "MIT-style"

"""
Use event.get to filter events processed
"""

import pygame
import sys, os

pygame.display.init()

size=(800,600)
screen=pygame.display.set_mode(size)
pygame.display.set_caption("Events")
screen=pygame.display.get_surface()

oClock=pygame.time.Clock()

while True:
    #oClock.tick(2)
    #print "tick"
    oClock.tick(60)
    if not pygame.event.peek([pygame.KEYUP,pygame.QUIT,pygame.KEYDOWN]):
        pygame.event.clear()
    else:
        for event in pygame.event.get([pygame.KEYUP,pygame.QUIT,pygame.KEYDOWN]):
            if event.type == pygame.QUIT:
                sys.exit()
            elif event.type == pygame.KEYUP and event.key == pygame.K_q:
                sys.exit()
            else:
                print event
