__author__ = "Neil Muller"
__copyright__ = "Copyright (c) 2007 Neil Muller"
__license__ = "MIT-style"

"""
Sound fun
"""

import pygame
import sys, os

pygame.display.init()
try:
    pygame.mixer.init(44100,-16)
except Exception, e:
    print "Unable to initialise sound mixer module"
    print e
    sys.exit()

size=(800,600)
screen=pygame.display.set_mode(size)
pygame.display.set_caption("sounds")
screen=pygame.display.get_surface()

name=os.path.join('sounds','wesnoth-1.ogg')
pygame.mixer.music.load(name)

name=os.path.join('sounds','hiss.wav')
oHiss=pygame.mixer.Sound(name)

pygame.mixer.music.play(10)

Clock=pygame.time.Clock()

count=0
while True:
    Clock.tick(30)
    event=pygame.event.poll()
    if event.type == pygame.QUIT:
        sys.exit()
    elif event.type == pygame.KEYUP and event.key == pygame.K_q:
        sys.exit()
    elif event.type == pygame.KEYUP and event.key == pygame.K_a:
        oHiss.play()
